exception Break

exception Internal_error of string
let internal_error s = raise (Internal_error s)

let fabs x = if x < 0. then 0.-.x else x
let nonZero x = not (-1e-100 <= x && x <= 1e-100)

let avaCLposition cl1 cl2 = (cl1-1)*cl1/2 + cl2
let unAVACLposition x =
  let cl1 = int_of_float (0.5 +. sqrt(0.25 +. 2. *. float_of_int x)) in
  let cl2 = x - cl1*(cl1-1)/2 in
    (cl1, cl2)


let isNone = function None -> true | _ -> false
let isSome = function None -> false | _ -> true
let fromSome = function Some x -> x | _ -> internal_error "fromSome on None"

let hash_size h = Hashtbl.fold (fun _ _ c -> c + 1) h 0

let dprintf fmt =
  Printf.kprintf (fun s -> print_string s ; flush stdout) fmt
