(* right now we just use hash tables *)
module H = Hashtbl

type vocabulary = V of (string, int) H.t * int ref

let create () = V (H.create 40, ref 0)

let get (V (v,id)) (s:string) =
  try
    H.find v s
  with
      Not_found -> ( let x = !id in H.add v s x ; incr id ; x )
    | e -> raise e

let size (V (_,id)) = !id

let iter (V (v,_)) f = H.iter f v

let set (V (v,id)) (s:string) (i:int) =
  if i >= !id then id := i+1;
  H.replace v s i

let global = create ()

let reverse v : string array =
  let a = Array.make (size v) "" in
    iter v (fun s i -> a.(i) <- s);
    a
